//
//  main.c
//  es_3-Liste
//
//  Created by Pumo on 25/12/12.
//  Copyright (c) 2012 Pumo. All rights reserved.
//

#include <stdio.h>
#include <stdlib.h>
#include "list.h"

list crossSelection(list l1, list l2);
int select(int num, list l2);

int main(int argc, const char * argv[])
{
    int num;
    list l1 = emptyList(), l2 = emptyList();
    list l3 = emptyList();
    
    printf("Inserisci gli elementi per la prima lista: \n");
    while (scanf("%d", &num) == 1 && num != 0)
        l1 = cons(num, l1);
    
    printf("Inserisci gli elementi per la prima lista: \n");
    while (scanf("%d", &num) == 1 && num != 0)
        l2 = cons(num, l2);
    
    // Reverse liste
    l1 = reverse(l1);
    l2 = reverse(l2);
    
    printf("\nLa lista risultato e': \n");
    l3 = crossSelection(l1, l2);
    showList(l3);
    
    
    printf("\n\n");
    system("PAUSE");
    return 0;
}

list crossSelection(list l1, list l2){
    int n;
    list l3;
    
    if (empty(l1)) return NULL;
    else
    {
        l3 = (list) malloc(sizeof(node));
    
        n = select(head(l1), l2);
        if (n == -1) {
            printf("Posizione non valida");
            exit(1);
        }
        else {
            l3 = cons(n, l3);
            l1 = tail(l1);
            l3->next= crossSelection(l1, l2);
            return l3;
        }
    }
}

int select(int num, list l2){
    int i = 0;
    int n;
    
    while (i < num){
        if (empty(l2)) return -1;
        n = head(l2);
        l2 = tail(l2);
        i++;
    }
    return n;
}