#ifndef ELEMENT
#define ELEMENT

#define MAXDIM 5

typedef struct{
    char name[21];
    int height;
} NomeStruct;


typedef enum {FALSE, TRUE} Boolean;

#if 0
typedef NomeStruct Element; // Nel caso di strutture
#endif

#if 1
typedef int Element; // Nel caso di interi
#endif

#if 0
typedef char Element; // Nel caso di stringhe
#endif


// OPERAZIONI
Element getElement(void);
void printElement(Element);

int compare(Element e1, Element e2); // <0 , 0 , >0
void swap(Element *e1, Element *e2);
void assign(Element *lvalue, Element rvalue);

// OPERAZIONI LISTE
Boolean isEqual(Element e1, Element e2);
Boolean isLess(Element e1, Element e2);

#endif

